//PLL CHIP
//Created Jonti 2006
//
//unsure about this chips registers.
//this driver is generic
//
//
// eg
//
// pll_init(POSITIVE_PHASE_DETECTOR|REFERENCE_OPTIMIZATION_FREQ_5_TO_50MHZ,POWERDOWN_NONE,13000,50,88100);
//
//


// CONSTANTS
#ifndef PLL_DATA
#define PLL_DATA        PIN_A3                  // Serial data pin
#endif
#ifndef PLL_CLOCK
#define PLL_CLOCK       PIN_A2                  // Clock pin
#endif
#ifndef PLL_LOAD
#define PLL_LOAD        PIN_A4                  // load enable pin
#endif

//R COUNTER
#define CP_TRI_STATE                   0x000800

#define POSITIVE_PHASE_DETECTOR        0x001000
#define NEGATIVE_PHASE_DETECTOR        0x000000

// LD settings dont seem to work on lmx2322
//#define LD_OUT_DIGITAL                 0x000000
//#define LD_OUT_ANALOG                  0x002000
//#define LD_OUT_R_DIVIDER               0x004000
//#define LD_OUT_N_DIVIDER               0x006000

#define REFERENCE_OPTIMIZATION_FREQ_5_TO_50MHZ 0x000000
#define REFERENCE_OPTIMIZATION_FREQ_50_TO_104MHZ 0x038000
//END R COUNTER

//N COUNTER
#define POWERDOWN_NONE                 0x000000
#define POWERDOWN_SYNC                 0x000002
#define POWERDOWN_COUNTERRESET         0x000004
#define POWERDOWN_ASYNC                0x000006
//END N COUNTER

void load_pll(int32 data)
{
int buf[3];
BYTE i,b;
buf[0] = (int) (data);
buf[1] = (int) (data >> 8);
buf[2] = (int) (data >> 16);
for(i=1;i<=(24-18);i++) shift_left(buf,3,0);    // don't use top 6 bits
output_low(PLL_CLOCK);
output_low(PLL_LOAD);
delay_us(2);
for(i=1;i<=18;i++)                           // put 18 bits into shit register MSB first
{
b=shift_left(buf,3,0);
output_bit(PLL_DATA,b);
delay_us(2);
output_high(PLL_CLOCK);
delay_us(2);
output_low(PLL_CLOCK);
delay_us(2);
}
delay_us(2);
output_high(PLL_LOAD);
delay_us(2);
output_low(PLL_LOAD);              // load data from shift register into N or R register
delay_us(2);
}

//
// Simple way to set the pll, if memory is critical do this by hand to save memory.
//
// let all freq have the same unit eg all khz, all mhz, or all hz. i suggest khz.
// sets frq to "bace freq"
// channel_spaceing will be the pll comparasen frequency
// fosc if the xtal frequency
// for proper frequency setting channel_spacing must divide bace frequency and fosc
void pll_init(int32 r_setup_param, int32 n_setup_param, int32 fosc, int16 channel_spacing, int32 base_freq)
{
int32 temp,na,nb;
temp = fosc / channel_spacing;     // calculate R counter
temp=temp<<1;
temp |= 1;
temp |= r_setup_param;
load_pll(temp);                 // load R counter in chip
temp = base_freq / channel_spacing;         // calculate N counter
nb=temp/32;
na=temp-nb*32;
nb=nb<<8;
nb &= 0x3FF00;
na=na<<3;
na &= 0x03FFF8;
na |= n_setup_param;
load_pll(na|nb);                 // load N counter in chip
}


